/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.builders.gui;

import java.io.IOException;

import net.minecraft.client.gui.GuiTextField;
import net.minecraft.util.ResourceLocation;

import buildcraft.lib.gui.GuiBC8;
import buildcraft.lib.gui.GuiIcon;
import buildcraft.lib.gui.pos.GuiRectangle;

import buildcraft.builders.container.ContainerArchitectTable;

public class GuiArchitectTable extends GuiBC8<ContainerArchitectTable> {
    private static final ResourceLocation TEXTURE_BASE = new ResourceLocation("buildcraftbuilders:textures/gui/architect.png");
    private static final int SIZE_X = 256, SIZE_Y = 166;
    private static final GuiIcon ICON_GUI = new GuiIcon(TEXTURE_BASE, 0, 0, SIZE_X, SIZE_Y);
    private static final GuiIcon ICON_PROGRESS = new GuiIcon(TEXTURE_BASE, 0, 166, 24, 17);
    private static final GuiRectangle RECT_PROGRESS = new GuiRectangle(159, 34, 24, 17);

    private GuiTextField nameField;

    public GuiArchitectTable(ContainerArchitectTable container) {
        super(container);
        field_146999_f = SIZE_X;
        field_147000_g = SIZE_Y;
    }

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        nameField = new GuiTextField(0, field_146289_q, field_147003_i + 90, field_147009_r + 62, 156, 12);
        nameField.func_146180_a(container.tile.name);
        nameField.func_146195_b(true);
    }

    @Override
    protected void drawBackgroundLayer(float partialTicks) {
        ICON_GUI.drawAt(mainGui.rootElement);
        drawProgress(
                RECT_PROGRESS,
                ICON_PROGRESS,
                container.tile.deltaProgress.getDynamic(partialTicks),
                1
        );
    }

    @Override
    protected void drawForegroundLayer() {
        nameField.func_146194_f();
    }

    @Override
    public void func_73876_c() {
        nameField.func_146178_a();
    }

    @Override
    protected void func_73869_a(char typedChar, int keyCode) throws IOException {
        boolean typed = false;
        if (nameField.func_146206_l()) {
            typed = nameField.func_146201_a(typedChar, keyCode);
            container.sendNameToServer(nameField.func_146179_b().trim());
        }
        if (!typed) {
            super.func_73869_a(typedChar, keyCode);
        }
    }

    @Override
    protected void func_73864_a(int mouseX, int mouseY, int mouseButton) throws IOException {
        super.func_73864_a(mouseX, mouseY, mouseButton);
        nameField.func_146192_a(mouseX, mouseY, mouseButton);
    }
}
